; Habbo Hotel B64 Encoder - x86 ASM (MASM)
; By Joe Hegarty

    .486 
    .model flat, stdcall 
    option casemap :none 
 
    include \masm32\include\windows.inc 
    include \masm32\macros\macros.asm   
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .code 


start: 
   
    mov eax, 34 ; EAX is the number we are decoding
    mov ebx, 2  ; EBX is the length of the output we want
    mov ecx, 1  ; ECX is our counter
    
    next_char:
        mov edx, ebx 
        sub edx, ecx
        imul edx, 6
        mov ebp, eax
        mov esi, 0
        do_shift:
            cmp esi, edx
            je shift_done
            shr ebp, 1
            inc esi
            jmp do_shift
            

        shift_done:
            and ebp, 63
            add ebp, 64

            pusha
            print chr$("ASCII Code: ")
            print str$(ebp)
            print chr$(13,10)
            popa
            
            
            cmp ecx, ebx
            je all_done

            inc ecx
            jmp next_char

    all_done:
        
        exit
    

end start
