#include "B64Encoding.h"

using namespace System;
using namespace System::Text;

System::String^ B64Encoding::encodeInt(int encValue, int encLength)
{
	StringBuilder^ buffer = gcnew StringBuilder(encLength);
	for (int x = 1; x <= encLength; x++)
	{
		int offset = 6 * (encLength - x);
		int val = 64 + (encValue >> offset & 0x3f);
		buffer->Append(System::Convert::ToChar(val));
	}
	return buffer->ToString();
}

int B64Encoding::decodeInt(System::String^ strVal)
{
	int intTot = 0;
	int y = 0;
	for (int x = strVal->Length - 1; x >= 0; x--)
	{
		int intTmp = static_cast<int>(strVal[x] - 64);
		if (y > 0)
		{
			intTmp = intTmp * static_cast<int>(System::Math::Pow(64, y));
		}
		intTot += intTmp;
		y++;
	}
	return intTot;
}