#include <string>
#include <math.h>

#include "Base64Encoding.h"

unsigned int Base64Encoding::DecodeInt(const char *psInput)
{
	unsigned int nResult = 0;
	unsigned int nCount = 0;
	for(size_t i = strlen(psInput); i > 0; i--)
	{
		unsigned int nTmp = psInput[i - 1] - 64;
		if (nCount > 0)
		{
			nTmp = (unsigned int) (nTmp * pow(64, (double) nCount));
		}
		nResult += nTmp;
		nCount++;
	}

	return nResult;
}

const char* Base64Encoding::EncodeInt(unsigned int nValue, unsigned int nLength)
{
	char* psReturn = new char[nLength + 1];
	psReturn[nLength] = '\0';

	for(unsigned int i = 1; i <= nLength; i++)
	{
		int nOffset = 6 * (nLength - i);
		char cVal = 64 + (nValue >> nOffset & 0x3f);
		psReturn[i - 1] = cVal;
	}
	return psReturn;
}
